#!/bin/bash
#
if [ -f /etc/linkat-caf-fix ]; then
	exit 0
fi
if [ -f /etc/profile.CA ]; then
	if [ -f /etc/init.d/CA-DSM ]; then
	   if [ -z "$(grep caf\ kill\ all /etc/init.d/CA-DSM)" ]; then
	      cp /etc/init.d/CA-DSM /etc/init.d/CA-DSM.bak
	      sed -i 's/sd_jexec\ unit/\#sd_jexec\ unit/g' /etc/init.d/CA-DSM
	      sed -i '/#sd_jexec\ unit=\.\ shutdown\ >>/a\\t\t\tcaf\ kill\ all\ \>\/dev\/null 2>&1' /etc/init.d/CA-DSM 
	   fi
	fi
	if [ "$(stat -c "%a" /opt/CA/CAlib)" != "755" ]; then
	   chmod 755 /opt/CA/CAlib
	fi
	BASE_DIR_CAF=/opt/CA/SharedComponents
	for i in bin cai18n ccs lib packager;
	do
		if [ -d "$BASE_DIR_CAF/$i" ]; then
			if [ "$(stat -c "%a" "$BASE_DIR_CAF/$i")" != "755" ]; then
			   chmod 755 $BASE_DIR_CAF/$i
			fi
                fi
	done
        if [ -f /opt/CA/SharedComponents/ccs/cam/cam.cfg ]; then
	   if [ -z "$(cat /opt/CA/SharedComponents/ccs/cam/cam.cfg|grep protocol|grep tcp|grep 4105)" ];then
                 rm /opt/CA/SharedComponents/ccs/cam/cam.cfg 
	   fi
	fi
        if [ ! -f /opt/CA/SharedComponents/ccs/cam/cam.cfg ]; then
	   #
	   # Checking Network Connectivity
	   #
	   WAIT_TIME=5m
	   FLAG=0
	   TEST_IPS="educaciodigital.cat ubuntu.com wikipedia.org"
	   TARGET=($(echo $TEST_IPS))
	   N_TARGET=${#TARGET[@]}
	   let 'N_TARGET -=1'
	   TEST_PORT=443
	   CURRENT_TEST_IP=0
	   while [ $FLAG -eq 0 ];
	   do
	      TESTIP=${TARGET[$CURRENT_TEST_IP]}
	      if [ -z "$(nmap  -p $TEST_PORT $TESTIP  2>/dev/null |grep open)" ]; then
	         if [ $CURRENT_TEST_IP -lt $N_TARGET ]; then   
	   	      let 'CURRENT_TEST_IP +=1'
	   	 else
	   	   CURRENT_TEST_IP=0
		   sleep $WAIT_TIME
	         fi
	      else
	      FLAG=1
	      fi
	   done
	   #
	   # CA check
	   #
	   sleep 30
           . /etc/profile.CA all
	   if [ -z "$(pidof caf)" ]; then
	      camclose
	      sleep 5
	      caf restart
	      sleep 5
	   fi
           camconfig udp_port=-1
           camsave persist
           camclose
           sleep 5
           caf restart
	   if [ -n "$(cat /opt/CA/SharedComponents/ccs/cam/cam.cfg|grep protocol|grep tcp|grep 4105)" ];then
	      echo "cam.cfg: Scalability server configured correctly / tcp connection OK"
	   else
	      echo "cam.cfg file: Scalability server not configured correctly / tcp connection KO"
	      if [ -f /opt/CA/SharedComponents/ccs/cam/cam.cfg ]; then
                 rm /opt/CA/SharedComponents/ccs/cam/cam.cfg 
              fi
	   fi
        fi
	sleep 5
	COUNTER=0
	for j in clamd freshclam caf cfsmsmd cfnotsrvd cfProcessManager cfFTPlugin hmagent
	do
	   PIDOF_CAF=$(pidof $j)
	   while [ -z "$(pidof $j)" ] && [ $COUNTER -le 6  ]; do
	      let COUNTER+=1
	      sleep 5s
	   done
	   if [ -n "$PIDOF_CAF" ]; then
		/usr/bin/renice -n 19 -p $PIDOF_CAF
		/usr/bin/ionice -c2 -n7 -p $PIDOF_CAF
	   fi
	done
fi
exit 0
